VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "ld_Ellipse"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Option Explicit

' The object we draw on.
Public Canvas As Object
Attribute Canvas.VB_VarHelpID = -1

' The ellipse's drawing attributes.
Private m_X1 As Single
Private m_Y1 As Single
Private m_X2 As Single
Private m_Y2 As Single
Public DrawWidth As Integer
Public ForeColor As OLE_COLOR
Public FillColor As OLE_COLOR
Public FillStyle As FillStyleConstants
Public DrawStyle As DrawStyleConstants

' Default properties.
Private Const m_def_X1 = 0
Private Const m_def_Y1 = 0
Private Const m_def_X2 = 120
Private Const m_def_Y2 = 120
Private Const m_def_DrawWidth = 1
Private Const m_def_ForeColor = vbBlack
Private Const m_def_FillColor = vbBlack
Private Const m_def_FillStyle = vbFSTransparent
Private Const m_def_DrawStyle = vbSolid

' True if the object is selected.
Public Selected As Boolean
' Set the rectangle's coorsdinates.
Public Sub SetCoordinates(ByVal X1 As Single, ByVal Y1 As Single, ByVal X2 As Single, ByVal Y2 As Single)
    If X1 < X2 Then
        m_X1 = X1
        m_X2 = X2
    Else
        m_X1 = X2
        m_X2 = X1
    End If
    If Y1 < Y2 Then
        m_Y1 = Y1
        m_Y2 = Y2
    Else
        m_Y1 = Y2
        m_Y2 = Y1
    End If
End Sub

' Initialize the object from its text serialization.
Public Property Let Serialization(ByVal new_serialization As String)
Dim token_name As String
Dim token_value As String

    ' Set defaults.
    SetDefaultProperties

    ' Set the property values.
    On Error GoTo PropertyError
    Do While Len(new_serialization) > 0
        ' Get the next token.
        GetToken new_serialization, token_name, token_value

        Select Case token_name
            Case "X1"
                m_X1 = CSng(token_value)
            Case "Y1"
                m_Y1 = CSng(token_value)
            Case "X2"
                m_X2 = CSng(token_value)
            Case "Y2"
                m_Y2 = CSng(token_value)
            Case "DrawWidth"
                DrawWidth = CInt(token_value)
            Case "ForeColor"
                ForeColor = CLng(token_value)
            Case "FillColor"
                FillColor = CLng(token_value)
            Case "FillStyle"
                FillStyle = CInt(token_value)
            Case "DrawStyle"
                DrawStyle = CInt(token_value)
            Case Else
                ErrorRecord "Unknown token '" & _
                    token_name & "' in Ellipse object"
        End Select
    Loop
    Exit Property

PropertyError:
    ErrorRecord "Error " & Format$(Err.Number) & _
        " processing Ellipse property '" & _
        token_name & "'" & vbCrLf & Err.Description
    Resume Next
End Property

' Draw on Canvas.
Public Sub Draw()
    ' See if the object is selected.
    If Selected Then
        ' It is selected.
        ' Draw in yellow to highlight it.
        Canvas.ForeColor = vbYellow
    Else
        ' It is not selected.
        ' Use its normal ForeColor.
        Canvas.ForeColor = ForeColor
    End If

    ' Set other drawing attributes.
    With Canvas
        .FillStyle = FillStyle
        .FillColor = FillColor
        .DrawWidth = DrawWidth
        .DrawStyle = DrawStyle
    End With

    ' Draw the object.
    DrawEllipse Canvas, m_X1, m_Y1, m_X2, m_Y2
End Sub
' Return the object's serialization.
Public Property Get Serialization() As String
Dim txt As String

    ' Build the serialization.
    If m_X1 <> m_def_X1 Then txt = txt & "X1(" & Format$(m_X1) & ")"
    If m_Y1 <> m_def_Y1 Then txt = txt & "Y1(" & Format$(m_Y1) & ")"
    If m_X2 <> m_def_X2 Then txt = txt & "X2(" & Format$(m_X2) & ")"
    If m_Y2 <> m_def_Y2 Then txt = txt & "Y2(" & Format$(m_Y2) & ")"
    If DrawWidth <> m_def_DrawWidth Then txt = txt & "DrawWidth(" & Format$(DrawWidth) & ")"
    If ForeColor <> m_def_ForeColor Then txt = txt & "ForeColor(" & Format$(ForeColor) & ")"
    If FillColor <> m_def_FillColor Then txt = txt & "FillColor(" & Format$(FillColor) & ")"
    If FillStyle <> m_def_FillStyle Then txt = txt & "FillStyle(" & Format$(FillStyle) & ")"
    If DrawStyle <> m_def_DrawStyle Then txt = txt & "DrawStyle(" & Format$(DrawStyle) & ")"

    Serialization = "Ellipse(" & txt & ")"
End Property


' Return True if the object is at this position.
Public Function IsAt(ByVal X As Single, ByVal Y As Single) As Boolean
    IsAt = (m_X1 <= X And m_X2 >= X And _
            m_Y1 <= Y And m_Y2 >= Y)
End Function


' Set default property values.
Private Sub SetDefaultProperties()
    m_X1 = m_def_Y1
    m_Y1 = m_def_X1
    m_X2 = m_def_Y2
    m_Y2 = m_def_X2
    DrawWidth = m_def_DrawWidth
    ForeColor = m_def_ForeColor
    FillColor = m_def_FillColor
    FillStyle = m_def_FillStyle
    DrawStyle = m_def_DrawStyle

    Selected = False
End Sub

' Set some defaults.
Private Sub Class_Initialize()
    SetDefaultProperties
End Sub
