VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "ld_Line"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = True
Option Explicit

' The object we draw on.
Public Canvas As Object
Attribute Canvas.VB_VarHelpID = -1

' The rectangle's drawing attributes.
Public X1 As Single
Public Y1 As Single
Public X2 As Single
Public Y2 As Single
Public DrawWidth As Integer
Public ForeColor As OLE_COLOR
Public FillColor As OLE_COLOR
Public FillStyle As FillStyleConstants
Public DrawStyle As DrawStyleConstants

' Default properties.
Private Const m_def_X1 = 0
Private Const m_def_Y1 = 0
Private Const m_def_X2 = 120
Private Const m_def_Y2 = 120
Private Const m_def_DrawWidth = 1
Private Const m_def_ForeColor = vbBlack
Private Const m_def_FillColor = vbBlack
Private Const m_def_FillStyle = vbFSTransparent
Private Const m_def_DrawStyle = vbSolid

' True if the object is selected.
Public Selected As Boolean
' Return the object's serialization.
Public Property Get Serialization() As String
Dim txt As String

    ' Build the serialization.
    If X1 <> m_def_X1 Then txt = txt & "X1(" & Format$(X1) & ")"
    If Y1 <> m_def_Y1 Then txt = txt & "Y1(" & Format$(Y1) & ")"
    If X2 <> m_def_X2 Then txt = txt & "X2(" & Format$(X2) & ")"
    If Y2 <> m_def_Y2 Then txt = txt & "Y2(" & Format$(Y2) & ")"
    If DrawWidth <> m_def_DrawWidth Then txt = txt & "DrawWidth(" & Format$(DrawWidth) & ")"
    If ForeColor <> m_def_ForeColor Then txt = txt & "ForeColor(" & Format$(ForeColor) & ")"
    If FillColor <> m_def_FillColor Then txt = txt & "FillColor(" & Format$(FillColor) & ")"
    If FillStyle <> m_def_FillStyle Then txt = txt & "FillStyle(" & Format$(FillStyle) & ")"
    If DrawStyle <> m_def_DrawStyle Then txt = txt & "DrawStyle(" & Format$(DrawStyle) & ")"

    Serialization = "Line(" & txt & ")"
End Property

' Initialize the object from its text serialization.
Public Property Let Serialization(ByVal new_serialization As String)
Dim token_name As String
Dim token_value As String

    ' Set defaults.
    SetDefaultProperties

    ' Set the property values.
    On Error GoTo PropertyError
    Do While Len(new_serialization) > 0
        ' Get the next token.
        GetToken new_serialization, token_name, token_value

        Select Case token_name
            Case "X1"
                X1 = CSng(token_value)
            Case "Y1"
                Y1 = CSng(token_value)
            Case "X2"
                X2 = CSng(token_value)
            Case "Y2"
                Y2 = CSng(token_value)
            Case "DrawWidth"
                DrawWidth = CInt(token_value)
            Case "ForeColor"
                ForeColor = CLng(token_value)
            Case "FillColor"
                FillColor = CLng(token_value)
            Case "FillStyle"
                FillStyle = CInt(token_value)
            Case "DrawStyle"
                DrawStyle = CInt(token_value)
            Case Else
                ErrorRecord "Unknown token '" & _
                    token_name & "' in Line object"
        End Select
    Loop
    Exit Property

PropertyError:
    ErrorRecord "Error " & Format$(Err.Number) & _
        " processing Line property '" & _
        token_name & "'" & vbCrLf & Err.Description
    Resume Next
End Property
' Draw on Canvas.
Public Sub Draw()
    ' See if the object is selected.
    If Selected Then
        ' It is selected.
        ' Draw in yellow to highlight it.
        Canvas.ForeColor = vbYellow
    Else
        ' It is not selected.
        ' Use its normal ForeColor.
        Canvas.ForeColor = ForeColor
    End If

    ' Set other drawing attributes.
    With Canvas
        .FillStyle = FillStyle
        .FillColor = FillColor
        .DrawWidth = DrawWidth
        .DrawStyle = DrawStyle
    End With

    ' Draw the object.
    Canvas.Line (X1, Y1)-(X2, Y2), Canvas.ForeColor
End Sub
' Return True if the object is at this position.
Public Function IsAt(ByVal X As Single, ByVal Y As Single) As Boolean
    IsAt = (DistToSegment(X, Y, X1, Y1, X2, Y2) < CLOSE_DIST)
End Function


' Set default property values.
Private Sub SetDefaultProperties()
    X1 = m_def_Y1
    Y1 = m_def_X1
    X2 = m_def_Y2
    Y2 = m_def_X2
    DrawWidth = m_def_DrawWidth
    ForeColor = m_def_ForeColor
    FillColor = m_def_FillColor
    FillStyle = m_def_FillStyle
    DrawStyle = m_def_DrawStyle

    Selected = False
End Sub

' Set some defaults.
Private Sub Class_Initialize()
    SetDefaultProperties
End Sub
