VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "ld_Circle"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = True
Option Explicit

' The object we draw on.
Public Canvas As Object
Attribute Canvas.VB_VarHelpID = -1

' The rectangle's drawing attributes.
Public X0 As Single
Public Y0 As Single
Public Radius As Single
Public DrawWidth As Integer
Public ForeColor As OLE_COLOR
Public FillColor As OLE_COLOR
Public FillStyle As FillStyleConstants
Public DrawStyle As DrawStyleConstants

' Default property values.
Private Const m_def_X0 = 0
Private Const m_def_Y0 = 0
Private Const m_def_Radius = 120
Private Const m_def_DrawWidth = 1
Private Const m_def_ForeColor = vbBlack
Private Const m_def_FillColor = vbBlack
Private Const m_def_FillStyle = vbFSTransparent
Private Const m_def_DrawStyle = vbSolid

' True if the object is selected.
Public Selected As Boolean
' Draw on Canvas.
Public Sub Draw()
    ' See if the object is selected.
    If Selected Then
        ' It is selected.
        ' Draw in yellow to highlight it.
        Canvas.ForeColor = vbYellow
    Else
        ' It is not selected.
        ' Use its normal ForeColor.
        Canvas.ForeColor = ForeColor
    End If

    ' Set other drawing attributes.
    With Canvas
        .FillStyle = FillStyle
        .FillColor = FillColor
        .DrawWidth = DrawWidth
        .DrawStyle = DrawStyle
    End With

    ' Draw the object.
    Canvas.Circle (X0, Y0), Radius, Canvas.ForeColor
End Sub
' Initialize the object from its text serialization.
Public Property Let Serialization(ByVal new_serialization As String)
Dim token_name As String
Dim token_value As String

    ' Set defaults.
    SetDefaultProperties

    ' Set the property values.
    On Error GoTo PropertyError
    Do While Len(new_serialization) > 0
        ' Get the next token.
        GetToken new_serialization, token_name, token_value

        Select Case token_name
            Case "X0"
                X0 = CSng(token_value)
            Case "Y0"
                Y0 = CSng(token_value)
            Case "Radius"
                Radius = CSng(token_value)
            Case "DrawWidth"
                DrawWidth = CInt(token_value)
            Case "ForeColor"
                ForeColor = CLng(token_value)
            Case "FillColor"
                FillColor = CLng(token_value)
            Case "FillStyle"
                FillStyle = CInt(token_value)
            Case "DrawStyle"
                DrawStyle = CInt(token_value)
            Case Else
                ErrorRecord "Unknown token '" & _
                    token_name & "' in Circle object"
        End Select
    Loop
    Exit Property

PropertyError:
    ErrorRecord "Error " & Format$(Err.Number) & _
        " processing Circle property '" & _
        token_name & "'" & vbCrLf & Err.Description
    Resume Next
End Property
' Return the object's serialization.
Public Property Get Serialization() As String
Dim txt As String

    ' Build the serialization.
    If X0 <> m_def_X0 Then txt = txt & "X0(" & Format$(X0) & ")"
    If Y0 <> m_def_Y0 Then txt = txt & "Y0(" & Format$(Y0) & ")"
    If Radius <> m_def_Radius Then txt = txt & "Radius(" & Format$(Radius) & ")"
    If DrawWidth <> m_def_DrawWidth Then txt = txt & "DrawWidth(" & Format$(DrawWidth) & ")"
    If ForeColor <> m_def_ForeColor Then txt = txt & "ForeColor(" & Format$(ForeColor) & ")"
    If FillColor <> m_def_FillColor Then txt = txt & "FillColor(" & Format$(FillColor) & ")"
    If FillStyle <> m_def_FillStyle Then txt = txt & "FillStyle(" & Format$(FillStyle) & ")"
    If DrawStyle <> m_def_DrawStyle Then txt = txt & "DrawStyle(" & Format$(DrawStyle) & ")"

    Serialization = "Circle(" & txt & ")"
End Property

' Return True if the object is at this position.
Public Function IsAt(ByVal X As Single, ByVal Y As Single) As Boolean
    IsAt = (X0 - X) * (X0 - X) + (Y0 - Y) * (Y0 - Y) < Radius * Radius
End Function


' Set default property values.
Private Sub SetDefaultProperties()
    X0 = m_def_Y0
    Y0 = m_def_X0
    Radius = m_def_Radius
    DrawWidth = m_def_DrawWidth
    ForeColor = m_def_ForeColor
    FillColor = m_def_FillColor
    FillStyle = m_def_FillStyle
    DrawStyle = m_def_DrawStyle

    Selected = False
End Sub

' Set some defaults.
Private Sub Class_Initialize()
    SetDefaultProperties
End Sub
